package com.gg.module;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import javax.microedition.khronos.opengles.GL10;

import com.gg.util.Constant;

public class DrawBackground
{	
		private FloatBuffer   mVertexBuffer;//ݻ
		  
	    private FloatBuffer mTextureBuffer;//ݻ
	
	    private int vCount;//α¼
	    
	    int drawableId;//ͼƬID 
	    
	    public float mAngleX;//XתĽǶ
	    public float mAngleY;//YתĽǶ
	    public float mAngleZ;//ZתĽǶ		
	    
	    public DrawBackground(int drawableId)
	    {
	    	this.drawableId=drawableId;
	    	
	    	//ʼ껺
	    	initVertex();
	
	    	//ʼ껺
	    	initTexture();
	    }
	    
	   
	    public void initVertex()
		{
			float x=Constant.LOGIC_WIDTH/2;//¼Xֵı
			
			float y=1f*2/2;//¼Yֵı
			
			float z=0;//¼Zֵı

			float[] vertices=
			{//Ķʼ
				-x,y,z,
				-x,-y,z,
				x,y,z,
				
				-x,-y,z,
				x,-y,z,
				x,y,z,
		
			};
			
			vCount=vertices.length/3;//
			//ݻ
			//vertices.length*4ΪһFloatĸֽ
			ByteBuffer vbb=ByteBuffer.allocateDirect(vertices.length*4);	
			vbb.order(ByteOrder.nativeOrder());//ֽ˳
			mVertexBuffer=vbb.asFloatBuffer();//תΪfloatͻ
			mVertexBuffer.put(vertices);//򻺳з붥
			mVertexBuffer.position(0);//ûʼλ			
			
		}
	   
	
	    public void initTexture()
		{//ͼƬʼ
			float[] textures=new float[vCount*2];//ͼƬΪ2
			
			int temp=0;
			
			//Ͻε
			textures[temp++]=0;
			textures[temp++]=0;
			
			textures[temp++]=0;
			textures[temp++]=1;
			
			textures[temp++]=1;
			textures[temp++]=0;
			
			
			//½ε
			textures[temp++]=0;
			textures[temp++]=1;
			
			textures[temp++]=1;
			textures[temp++]=1;
			
			textures[temp++]=1;
			textures[temp++]=0;
		
			//ݻ
			//vertices.length*4ΪһFloatĸֽ
			ByteBuffer tbb=ByteBuffer.allocateDirect(textures.length*4);	
			tbb.order(ByteOrder.nativeOrder());//ֽ˳
			mTextureBuffer=tbb.asFloatBuffer();//תΪfloatͻ
			mTextureBuffer.put(textures);//򻺳з붥
			mTextureBuffer.position(0);//ûʼλ	
		}
		
	    
		public void drawSelf(GL10 gl)
		{
			gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);//ö
			gl.glVertexPointer(3, GL10.GL_FLOAT, 0, mVertexBuffer);//Ϊָ
	
			gl.glEnable(GL10.GL_TEXTURE_2D);//
			gl.glEnableClientState(GL10.GL_TEXTURE_COORD_ARRAY);//
			gl.glTexCoordPointer(2, GL10.GL_FLOAT, 0, mTextureBuffer);//ΪָͼƬ
			gl.glBindTexture(GL10.GL_TEXTURE_2D, drawableId);//ͼƬ
		
			gl.glRotatef(mAngleX, 1, 0, 0);//XתmAngleX
	 		gl.glRotatef(mAngleY, 0, 1, 0);//YתmAngleY
	 		gl.glRotatef(mAngleZ, 0, 0, 1);//ZתmAngleZ
			
			gl.glDrawArrays(GL10.GL_TRIANGLES, 0, vCount);//Ʊ
			
			gl.glDisableClientState(GL10.GL_VERTEX_ARRAY);
		}


		public int getDrawableId() {
			return drawableId;
		}


		public void setDrawableId(int drawableId) {
			this.drawableId = drawableId;
		}
		
		
		
	    
	}