package com.gg.util;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import javax.microedition.khronos.opengles.GL10;

public class TextureRect {

	private float TABLE_UNIT_SIZE = 0.5f;
	private float TABLE_UNIT_HIGHT = 0.5f;
	
	private FloatBuffer   mVertexBuffer;//ݻ
    private FloatBuffer mTextureBuffer;//ݻ
    int vCount=0;
    int texId;
    
    public TextureRect(float width,float height, float length,int texId,float[] texST)
    {
    	this.texId=texId;
    	//ݵĳʼ================begin============================
        vCount=6;
        float vertices[]=new float[]
        {
        	-width*TABLE_UNIT_SIZE,height*TABLE_UNIT_HIGHT,-length*TABLE_UNIT_SIZE,
        	-width*TABLE_UNIT_SIZE,-height*TABLE_UNIT_HIGHT,length*TABLE_UNIT_SIZE,     
        	width*TABLE_UNIT_SIZE,-height*TABLE_UNIT_HIGHT,length*TABLE_UNIT_SIZE,
        	
        	width*TABLE_UNIT_SIZE,-height*TABLE_UNIT_HIGHT,length*TABLE_UNIT_SIZE,
        	width*TABLE_UNIT_SIZE,height*TABLE_UNIT_HIGHT,-length*TABLE_UNIT_SIZE,     
        	-width*TABLE_UNIT_SIZE,height*TABLE_UNIT_HIGHT,-length*TABLE_UNIT_SIZE,
        };
		
        //ݻ
        //vertices.length*4Ϊһĸֽ
        ByteBuffer vbb = ByteBuffer.allocateDirect(vertices.length*4);
        vbb.order(ByteOrder.nativeOrder());//ֽ˳
        mVertexBuffer = vbb.asFloatBuffer();//תΪFloatͻ
        mVertexBuffer.put(vertices);//򻺳з붥
        mVertexBuffer.position(0);//ûʼλ
        //رʾڲͬƽֽ̨˳ͬݵԪֽڵһҪByteBuffer
        //תؼҪͨByteOrdernativeOrder()пܻ
        //ݵĳʼ================end============================
        ByteBuffer tbb = ByteBuffer.allocateDirect(texST.length*4);
        tbb.order(ByteOrder.nativeOrder());//ֽ˳
        mTextureBuffer = tbb.asFloatBuffer();//תΪintͻ
        mTextureBuffer.put(texST);//򻺳з붥ɫ
        mTextureBuffer.position(0);//ûʼλ         
        
    }

    public void drawSelf(GL10 gl)
    {        
        gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);//ö
        
		//Ϊָ
        gl.glVertexPointer
        (
        		3,				//ÿΪ3  xyz 
        		GL10.GL_FLOAT,	//ֵΪ GL_FLOAT
        		0, 				//֮ļ
        		mVertexBuffer	//
        );
        
        //
        gl.glEnable(GL10.GL_TEXTURE_2D);   
        //ʹST껺
        gl.glEnableClientState(GL10.GL_TEXTURE_COORD_ARRAY);
        //ΪָST껺
        gl.glTexCoordPointer(2, GL10.GL_FLOAT, 0, mTextureBuffer);
        //󶨵ǰ
        gl.glBindTexture(GL10.GL_TEXTURE_2D, texId);
        
		
        //ͼ
        gl.glDrawArrays
        (
        		GL10.GL_TRIANGLES, 		//ηʽ
        		0, 			 			//ʼ
        		vCount					//
        );
    }
}
